                .LF     dice2.lst
;------------------------------------------------------------------------
;
;  dice2.asm
;
;  A simple 2 dice rolling game
;
;  Author : San Bergmans
;  Date   : 15-12-2005
;
;------------------------------------------------------------------------
;
;  This program abuses the Z80's refresh register to generate pseudo
;  random numbers which are translated to two dice rolls.
;
;------------------------------------------------------------------------

                .CR     Z80             Yeah! We're programming the Z80!
                .OR     01800H          RAM starts here, so are we
                .TF     dice2.hex,HEX   Create a plain hex dump file

;------------------------------------------------------------------------
;  Monitor routines
;------------------------------------------------------------------------

SCAN            .EQ     005FEH          Scan display until a key pressed
HEX7            .EQ     00689H          Convert digit to 7-segement
TONE            .EQ     005E4H          Generate tone (C=freq, HL=cycles)

;------------------------------------------------------------------------
;  DICE
;------------------------------------------------------------------------

DICE            LD      A,R             Copy refresh register and use it
                RLA                      as a  pseudo random number
                LD      L,A
                RLCA                    Prepare random number for 2nd
                RLCA                     die
                RLCA
                LD      B,A

                LD      H,0             Multiply random number by 6
                ADD     HL,HL            this results in a range from
                LD      D,H               0..5
                LD      E,L             (Hint: ADD HL,HL ---> HL x 2)
                ADD     HL,HL
                ADD     HL,DE
                LD      A,H
                INC     A               Make it range from 1..6
                CALL    HEX7            Convert it to 7-segments
                LD      (DSP_BFFR+4),A   and display it

                LD      L,B             Do the same for the second die
                LD      H,0
                ADD     HL,HL
                LD      D,H
                LD      E,L
                ADD     HL,HL
                ADD     HL,DE
                LD      A,H
                INC     A
                CALL    HEX7
                LD      (DSP_BFFR+1),A

                LD      IX,DSP_BFFR     Scan the display until a key
                CALL    SCAN             is pressed
                LD      C,68            Set default system beep freq.
                LD      HL,47            and duration
                CALL    TONE            Sound beep
                JR      DICE            That's all! Do it again & again

;------------------------------------------------------------------------

DSP_BFFR        .DA     #0              Display buffer (from right to
                .DA     #0               left)
                .DA     #0
                .DA     #0
                .DA     #0
                .DA     #0

;------------------------------------------------------------------------

                .LI     OFF
